//-------------- Preferences Object

/*
# Gnophone type preferences (~/.gnophone/telco.cfg)
mode=2
iaxserver=asterisk.sysnux.pf
iaxcontext=gnophone
iaxusername=jdg
iaxpassword=jdg
iaxpeer=jdg
iaxsecret=jdg
iaxprefix=
iaxport=5036

# GastMan type preferences (~/.gastman/asterisk.sysnux.pf.extens)
:Modem[i4l]/ttyI0:programmer:333:236:OPT2
0:Modem[i4l]/ttyI0:programmer:324:86:OPT1
12:SIP/sip2:programmer:86:186:Laurent
11:SIP/sip1:programmer:88:53:Jean-Denis
*/

try {
	include (jslib_file);
	include (jslib_fileutils);
	include (jslib_dirutils);
	include (jslib_dir);
} catch( e ) { 
	if(typeof(alert)!='undefined')
		alert(e);
}

function Preferences() { // Constructor

	// Properties and default values
	this.alaw  = 'true';
	this.ulaw  = 'true';
	this.speex = 'true';
	this.gsm   = 'true';
	this.fop = '';
	this.devices = '';
	this.history_max = '';
	this.ast_host = '';
	this.iax_port = '';
	this.iax_peer = '';
	this.iax_secret = '';
	this.man_port = '';
	this.man_username = '';
	this.man_secret = '';
	this.browser_path = '';
	this.concurrency = '';
	this.AGC = '';
	this.EC = '';
	this.DN = '';
	this.silence = '';
	this.gmanage = '';
	this.callconf = '';
	this.autohide = '';
	this.queues = '';
	this.input = '';
	this.output = '';
	this.ring = '';
	this.pref_codec = '';
	this.history_max = '';
	this.history = new Array();
	this.dialpad = '';
	this.levels = '';
	this.hide_cid = 'false';
	this.auto_answer = 'false';
	this.auto_start = 'false';
	this.gui = 'window'; // window or sidebar

	//Methods
	this.save = save;
	this.load = load;
}

function load() {
	var du = new DirUtils();
	var fu = new FileUtils();

	if (typeof(window)!='undefined' && window.arguments && window.arguments[0] 
			&& window.arguments[0].url.indexOf('|ast_host=') > 0) {
		var a = new Array();
		a=window.arguments[0].url.split('|');
		window.arguments[0].url=a[0];
		for (var i=1; i<a.length; i++) {
			if (a[i].indexOf('host=') > 0) { this.ast_host=a[i].substring( (a[i].indexOf('=')+1) ); }
			if (a[i].indexOf('peer=') > 0) { this.iax_peer=a[i].substring( (a[i].indexOf('=')+1) ); }
			if (a[i].indexOf('secret=') > 0) { this.iax_secret=a[i].substring( (a[i].indexOf('=')+1) ); }
			if (a[i].indexOf('codec=') > 0) { this.pref_codec=a[i].substring( (a[i].indexOf('=')+1) ); }
		}
		if (this.iax_secret == "") { this.iax_secret=prompt('iax secret'); }
	   return;
	}

	// Search for preferences in mozphone directory (~/.mozphone)
	// Should we use Mozilla's preferences infrastructure ?
	var d = new Dir( du.getHomeDir() );
	d.append( '.mozphone' );
	if( ! d.exists() ) d.create();
	var d = new Dir( du.getHomeDir() );
	d.append( '.mozphone' );
	this.image_dir = d.path;
	this.pref_file = fu.append( d.path, 'prefs' );;
	var f = new File( this.pref_file );
	if( ! f.exists() ) prefs_dlg();
	f.open();
	var a = new Array();
	// Default values
	this.alaw  = 'true';
	this.ulaw  = 'true';
	this.speex = 'true';
	this.gsm   = 'true';
	this.fop = '';
	this.devices = new Array();
	this.history_max = 25;
	this.browser_pref= 'browser_new_tab';
	// Parse preferences
	while( !f.EOF ) {
		var l = f.readline();
		a = l.split('=');
		switch( a[0] ) {
			case 'ast_host':
				this.ast_host = a[1];
				break;
			case 'iax_port':
				this.iax_port = a[1];
				break;
			case 'iax_peer':
				this.iax_peer = a[1];
				break;
			case 'iax_secret':
				this.iax_secret = a[1];
				break;
			case 'man_port':
				this.man_port = a[1];
				break;
			case 'man_username':
				this.man_username = a[1];
				break;
			case 'man_secret':
				this.man_secret = a[1];
				break;
			case 'browser_path':
				this.browser_path = a[1];
				break;
			case 'browser_pref':
				this.browser_pref = a[1];
				break;
			case 'concurrency':
				this.concurrency = a[1];
				break;
			case 'AGC':
				this.AGC = a[1];
				break;
			case 'EC':
				this.EC = a[1];
				break;
			case 'DN':
				this.DN = a[1];
				break;
			case 'silence':
				this.silence = a[1];
				break;
			case 'debug':
				this.debug = a[1];
				break;
			case 'gmanage':
				this.gmanage = a[1];
				break;
			case 'callconf':
				this.callconf = a[1];
				break;
			case 'autohide':
				this.autohide = a[1];
				break;
			case 'queues':
				this.queues = a[1];
				break;
			case 'fop':
				this.fop = a[1];
				break;
			case 'input':
				this.input = a[1];
				break;
			case 'output':
				this.output = a[1];
				break;
			case 'ring':
				this.ring = a[1];
				break;
			case 'ilbc':
				this.ilbc = a[1];
				break;
			case 'speex':
				this.speex = a[1];
				break;
			case 'gsm':
				this.gsm = a[1];
				break;
			case 'ulaw':
				this.ulaw = a[1];
				break;
			case 'alaw':
				this.alaw = a[1];
				break;
			case 'pref_codec':
				this.pref_codec = a[1];
				break;
			case 'history_max':
				this.history_max = a[1];
				break;
			case 'history':
				// Drop down call history
				this.history.push(a[1]);
				break;
			case 'dialpad':
				this.dialpad = a[1];
				break;
			case 'levels':
				this.levels = a[1];
				break;
			case 'hide_cid':
				this.hide_cid = a[1];
				break;
			case 'auto_answer':
				this.auto_answer = a[1];
				break;
			case 'auto_start':
				this.auto_start = a[1];
				break;
			case 'gui':
				this.gui = a[1];
				break;
			default:
//				if(debug && debug == 'funtion' )
//					debug( 'Unknown preference: "' + l + '"<br>');
				break;
		}
	}
}

// Save preferences to file
function save() {
	var f = new File( prefs.pref_file );
/* XXX	if( f.exists() ) { 
	f.copy( home_dir + '.mozphone/prefs.OLD' );
		f.remove();
		} */
	if( f.open("w", 0600) != null ) {
		f.write( 'ast_host='     + this.ast_host + '\n');
		f.write( 'iax_port='     + this.iax_port + '\n');
		f.write( 'iax_peer='     + this.iax_peer + '\n');
		f.write( 'iax_secret='   + this.iax_secret + '\n');
		f.write( 'man_port='     + this.man_port + '\n');
		f.write( 'man_username=' + this.man_username + '\n');
		f.write( 'man_secret='   + this.man_secret + '\n');
		f.write( 'browser_path=' + this.browser_path + '\n' );
		f.write( 'browser_pref=' + this.browser_pref + '\n' );
		f.write( 'concurrency='  + this.concurrency + '\n' );
		f.write( 'AGC='          + this.AGC + '\n' );
		f.write( 'EC='           + this.EC + '\n' );
		f.write( 'DN='           + this.DN + '\n' );
		f.write( 'silence='      + this.silence + '\n' );
		f.write( 'debug='        + this.debug + '\n' );
		f.write( 'gmanage='      + this.gmanage + '\n' );
		f.write( 'callconf='     + this.callconf + '\n' );
		f.write( 'autohide='     + this.autohide + '\n' );
		f.write( 'queues='       + this.queues + '\n' );
		f.write( 'fop='          + this.fop + '\n' );
		f.write( 'input='        + this.input + '\n' );
		f.write( 'output='       + this.output + '\n' );
		f.write( 'ring='         + this.ring + '\n' );
		f.write( 'ilbc='         + this.ilbc + '\n' );
		f.write( 'speex='        + this.speex + '\n' );
		f.write( 'gsm='          + this.gsm + '\n' );
		f.write( 'ulaw='         + this.ulaw + '\n' );
		f.write( 'alaw='         + this.alaw + '\n' );
		f.write( 'pref_codec='   + this.pref_codec + '\n' );
		f.write( 'dialpad='      + this.dialpad + '\n' );
		f.write( 'levels='       + this.levels + '\n' );
		f.write( 'hide_cid='     + this.hide_cid + '\n' );
		f.write( 'auto_answer='  + this.auto_answer + '\n' );
		f.write( 'auto_start='   + this.auto_start + '\n' );
		f.write( 'gui='          + this.gui + '\n' );

		// Call history
		for( var i=0; i<this.history.length; i++ ) {
				f.write( 'history=' +  this.history[i] + '\n' );
		}
		f.close();
	} else 
		if(typeof(alert)!='undefined')
			alert( strings.getString('save_error') );
}
